
#################################################
# CONSTANTS:
#	System information
#################################################
DATABASE=$MX_DB_PATH
FACTORY_DEFAULT_DATABASE=/etc/mxAgent/moxa-factory.db
TEMPORARY_DATABASE=/dev/shm/temporary.db
SQLITE="sqlite3"
SQLITE_OPT=""
SQLITE_LOPT="--line -header"
MX_FORMAT="sed 's:\(.*\) = \(.*\):export \1=\\\"\2\\\" ;:g'"
LOOP_TIMER=1
DEFAULT_START_DIR="/etc/default/"
PROJECT_ROOT_DIR="/usr/local/bin/"
POLICY_ROOT_DIR="${PROJECT_ROOT_DIR}/policies/"
TEMP_FILE="/dev/shm/mxtemp"
export PATH=$PATH:${PROJECT_ROOT_DIR}
FIRMWARE_VERSION="1.0.0.0"
PRODUCT_NAME="DA-682A-LX"
# event register configuration file
MXINIT_CONFIG_FILE="${PROJECT_ROOT_DIR}/mxRegister.config"

#################################################
# Private Funtions
#################################################

_perror()
{
    echo "Error: $1" 2>&1
}

#################################################
# FUNCTION:
#	sql query with long options
#   show result like following:
#        id = 1
#        status = 0
#        val = 0
# WARNING: 
#   1. Unless error, the low level function shouldn't echo any message 
#	(or it will cause upper level function error)
#################################################
_sql_query()
{
    local option=$1
    local query=$2
	while [ 1 ]; do
		local REST
		REST=`${SQLITE} $option ${DATABASE} "$query" 2>&1`
        if [ "$?" == 0 ]; then
            if [ ! -z "${REST}" ]; then
		echo "${REST}"
            fi
            return 0
        elif [ "${REST}" == "Error: database is locked" ]; then
			sleep ${LOOP_TIMER}
        else 
			#echo "SQL ERROR: <${REST}>"
			#echo "Your query string=\"$query\""
            return 1;
        fi
	done
}

gb_sql_query_lopt ()
{
	_sql_query "${SQLITE_LOPT}" "$1"
    return $?
}

#################################################
# FUNCTION:
#	import variable from sql to current env
#################################################
gb_import_var()
{
	RSTL="`echo \"${1}\"|sed 's:\(.*\) = \(.*\):export \1=\"\2\" ;:g'`"
	eval ${RSTL}
}


