#!/bin/sh
################################################# 
# ETHERNET SCRIPT GENERATOR
# TODO:
#	read data from sqlite
#	setting ethernet
#################################################


source $MX_SCRIPT_PATH/mx_global.sh
source $MX_SCRIPT_PATH/snmp/global.sh

table=$mx_di_table
dio_tool="$MX_SCRIPT_PATH/snmp/mx_dio_tool"
num_port=`gb_table_get_row_count $table`
port_last=`expr $num_port - 1`
gb_debug_enable=0

send_di_trap() 
{
	local port_id=$1
	local trap_value=$2
	local trap_id="MOXA-SYS-MIB::ioDiChange"
	local trap_oid=".1.3.6.1.4.1.8691.17.1.6.1.1.2.1.3.$port_id"

	gb_debug "--------------send di trap"
	gb_sql_import_row_var "SELECT trapIp, trapCommunity FROM $mx_sys_table" 
	# put in background to reduce execute time
	snmptrap -v 2c -c $trapCommunity $trapIp "" $trap_id $trap_oid i $trap_value &
}

get_enableTrap_array()
{
	local i=0
	local val
	local list=`gb_sql_query "SELECT enableTrap FROM $table"`

	for val in  $list; do
		enableTrap[$i]=$val
		i=`expr $i + 1`
	done

	# clear control table status
	ctrl_status=`gb_control_table_get $table`
	#gb_debug "ctrl_status=$ctrl_status"
	#if [ "${ctrl_status}" -eq 1 ]; then
	if [ x"$ctrl_status" == x"1" ]; then
		gb_debug "-------------Clear control table"
		gb_control_table_clear $table
	fi
}

#get_cur_val_array()
#{
#	local port=0
#	cur_vals=`gb_sql_query "SELECT value from $table"`
#	for val in $cur_vals; do
#		cur_val[$port]=$val
#		port=`expr $port + 1`
#	done
#
#}
#

write_cur_val_array_to_file()
{
	> $mx_di_file
	for ((i=0; i<${#cur_val[@]}; i++)) do
		echo "cur_val[$i]=${cur_val[$i]}" >> $mx_di_file
	done
}

get_cur_val_array()
{
	if [ -f $mx_di_file ]; then
		. $mx_di_file
		#gb_debug "read from file"
	else 
		local port=0
		cur_vals=`gb_sql_query "SELECT value from $table"`
		#gb_debug "read from db table"
		for val in $cur_vals; do
			cur_val[$port]=$val
			port=`expr $port + 1`
		done
		write_cur_val_array_to_file
	fi

}

#################################################
# STARTING POINT:
#################################################

#gb_debug "$0: start scan"

get_cur_val_array

get_enableTrap_array


# compare with detect value
for port in `seq 0 $port_last`; do 
	new_val[$port]=`$dio_tool -g -p $port`
	#gb_debug "cur[$port]=${cur_val[$port]} new[$port]=${new_val[$port]}"

	if [ ${cur_val[$port]} -ne ${new_val[$port]} ]; then
		#gb_debug "DI$port is changed to ${new_val[$port]}" 
		gb_sql_query "UPDATE $table SET status=1, value=${new_val[$port]} WHERE portNumber=$port"
		cur_val[$port]=${new_val[$port]}

		#trap
		if [ ${enableTrap[$port]} -eq 1 ]; then 
			port_id=`expr $port + 1 `
			send_di_trap $port_id ${new_val[$port]}
		fi
	fi
	
done

write_cur_val_array_to_file
	
