#!/bin/bash
################################################# 
# SYSTEM INFO UPDATER
# TODO:
#################################################

. ${MX_SCRIPT_PATH}/mx_global.sh
. ${MX_SCRIPT_PATH}/snmp/global.sh

#################################################
# STARTING POINT:
#################################################

# Init variable
upTime=0
tempDiskInfo="/dev/shm/.disk_info"

# Update system info table
totalUpTime=`gb_sql_query "SELECT totalUptime FROM ${mx_system_info_table};"`

#cpuIdle=`cpu|awk {'print $7'}|cut -d '=' -f 2|tr -d [%\)]`
# Not to support cpuUsage, this define 
#cpuUsage=`echo "100-${cpuIdle}" | bc`
cpuIdle=`mpstat -P ALL|grep all|awk {'print $(NF)'}`
cpuUsage=`echo "100-${cpuIdle}" | bc`

memTotal=`free | grep "Mem:" | awk '{print $2}'`
memUsed=`free | grep "cache:" | awk '{print $3}'`
memUsage=`echo "scale=2;${memUsed}*100/${memTotal}" | bc -l`

totalUptime=`echo "scale=2;${totalUptime}-${upTime}" | bc -l`
bootTime=`vmstat -s | grep "boot time" | awk '{print $1}'`
nowTime=`date +%s`
upTime=`echo "scale=0;(${nowTime}-${bootTime})/60" | bc -l`
totalUptime=`echo "scale=0;${totalUptime}+${upTime}" | bc -l`

gb_sql_query "UPDATE ${mx_system_info_table} SET cpuUsage=${cpuUsage}, memUsage=${memUsage}, uptime=${upTime}, totalUptime=${totalUptime};"

# system memory
memSize=`free|grep "Mem"|awk {'print $2'}`

# update info to temporary file
 fdisk -l|grep "^/dev/" > ${tempDiskInfo}
volumeCount=0
sql_prep=''

# Update system storage table
while read line
do
	volumeName=''; volumeSize=''; volumeAvailable=''; volumeLabel='';
	volumeName=`echo "${line}"|awk {'print $1'}`
	volumeSize=`df -h ${volumeName}|grep "${volumeName}"|tail -n 1|awk {'print $2'}`
	volumeAvailable=`df -h ${volumeName}|grep "${volumeName}"|tail -n 1|awk {'print $4'}`
	# list only mount point 
	if [ -n "${volumeName}" ] && [ -n "${volumeSize}" ] && [ -n "${volumeAvailable}" ]; then
		unset disk_info;
		# each line refer to how many volume we have
		volumeCount=`expr ${volumeCount} + 1`
		volumeLabel=`blkid ${volumeName}|awk {'print $2'}|cut -d '=' -f 2|tr -d [\"]`
		#echo "volumeName=${volumeName} volumeLabel=${volumeSize} volumeAvailable=${volumeAvailable} volumeLabel=${volumeLabel}"

		# Let make an assumption here.
		# The DB default do not have any mxSystemVolume.
		# Upon the booting process, We scan the volume and add it dynamically.
		# Check out the DB if exits
		disk_count=`gb_sql_query "SELECT COUNT() FROM ${mx_system_volume_table} WHERE volumeName='${volumeName}';"`
		if [ x"$disk_count" ==  x"0" ]; then
		#if [ ${disk_count} -eq 0 ]; then
			# no record yet
			gb_sql_query "INSERT INTO ${mx_system_volume_table} (volumeName, volumeLabel, volumeSize, volumeAvailable) VALUES ('${volumeName}', '${volumeLabel}', '${volumeSize}', '${volumeAvailable}');"
		else
			# already have record
			gb_sql_query "UPDATE ${mx_system_volume_table} SET volumeLabel='${volumeLabel}', volumeSize='${volumeSize}', volumeAvailable='${volumeAvailable}' WHERE volumeName='${volumeName}' ;"
		fi

		# Prepare sql to remove DB row which is unnecessary
		if [ "${sql_prep}" == "" ]; then
			sql_prep="volumeName!='${volumeName}'"
		else
			sql_prep="${sql_prep} AND volumeName!='${volumeName}'"
		fi
	fi
done < ${tempDiskInfo}

# update mxSystemStorage
gb_sql_query "UPDATE ${mx_storage_table} SET memSize='${memSize}', volumeCount='${volumeCount}' ;"

# Last, remove disk info in DB that dynamic plug/unplug
gb_sql_query "DELETE FROM mxSystemVolume WHERE ${sql_prep};"
